#pragma once

#include "Device.h"
#include "Plugin_Header.h"

// Basic Devices: Inherit from these if your device is a Parameter or Scalar device.
class ParamDevice : public Device {
public:
	ParamDevice();
	virtual dword Color() { return 0x0f4dddd; };
	virtual int GetDeviceFamily() { return TYPE_PARAM; };

	virtual bool isViewable() { return false; };
	virtual bool isMaskable() { return false; };

	virtual bool getSpeedClass() { return 5; };


	virtual char *GetInputName(int slot);
	virtual char *GetOutputName(int slot);
	
	virtual WMPacket *getDefaultOutput(PSTATE preview);
	virtual void Reset(PSTATE which = P_ALL);		// for getDefaultOutput to preview properly, need to
													// modify the reset behavior to falsify.
	virtual void Preview();	// Have to overload preview so that the descendant gets built first for previwing this part
};

class ScalarDevice : public ParamDevice {
public:
	ScalarDevice();

	virtual char *GetInputName(int slot);
	virtual char *GetOutputName(int slot);
};

class CoordDevice : public ParamDevice {
public:
	CoordDevice();

	virtual char *GetInputName(int slot);
	virtual char *GetOutputName(int slot);
};
