#pragma once
#include "wmpacket.h"

class CoordPacket :
	public WMPacket
{
public:
	CoordPacket(void);
	virtual ~CoordPacket(void);

	CoordPacket(const CoordPacket &other);		// copy construction
	CoordPacket &operator=(const CoordPacket &other);

	virtual int getHeapUsage() { return 0;	};

	virtual int getType() { return WMP_coord; };
	virtual char *getTypeName() { return "Coordinate"; };

	virtual WMPacket *Clone();
	virtual bool Load(std::istream &input) { assert(false); return false; };	
	virtual bool Save(std::ostream &output) { assert(false); return false; };	

	virtual dword Color() { return 0x0ffff00; };

	CoordF get() { return location; };
	void set(CoordF &_l) { location = _l; };

	SizeData &getSizeData() { return sd; };

protected:
	virtual void Kill();		// Call to delete its own type
	virtual void clearContents() { };

	CoordF	location;		// coordinates
	int coord_mode;			// 0 = world, 1 = local

// SizeData carried along
	SizeData sd;			// Local-space size data

};

inline CoordPacket *LOC(WMPacket *pack) { 
	if (pack) {
		bool ok = pack->getType() == WMP_coord;
		assert(ok);
		if (!ok)
			return NULL;
	}
	return (CoordPacket*) pack; 
};
