/*

  Filter: An effect sprocket that produces 1 or more outputs from 1 or more inputs

  Your device will typically be derived from one of the base types in this header

  */

#pragma once
#if !defined(AFX_FILTER_H__7ECDF35C_FE0C_47B4_9845_02BF3998EEA9__INCLUDED_)
#define AFX_FILTER_H__7ECDF35C_FE0C_47B4_9845_02BF3998EEA9__INCLUDED_

#include "device.h"
#include "Plugin_Header.h"

class  Filter : public Device  
{
public:
	Filter();
	virtual dword Color() { return 0x0d5935e; }; 
	virtual int GetDeviceFamily() { return TYPE_FILTER; };
	virtual bool getSpeedClass() { return 4; };
};

class  CombineFilter : public Filter {
public:
	CombineFilter();
	virtual dword Color() { return 0x0b0723d; }; 
	virtual int GetDeviceFamily() { return TYPE_COMBINER; };
	virtual bool isMaskable() { return false; };
	virtual bool getSpeedClass() { return 4; };
};

class  NaturalFilter : public Filter {
public:
	NaturalFilter();
	virtual dword Color() { return 0x0456f9c; }; 
	virtual int GetDeviceFamily() { return TYPE_NATURAL; };
	virtual bool getSpeedClass() { return 0; };
};

class Selector : public Device  
{
public:
	Selector();
	virtual dword Color() { return 0x0965096; }; 
	virtual int GetDeviceFamily() { return TYPE_SELECTOR; };

	virtual bool getSpeedClass() { return 5; };
	virtual bool isMaskable() { return true; };
protected:
	virtual void MaskOutput(WMPacket *map, int slotnum, PSTATE preview);
};

class Utility : public Device {
public:
	Utility();
	virtual dword Color() { return 0x06699ff; }; 
	virtual int GetDeviceFamily() { return TYPE_UTILITY; };

	virtual bool getSpeedClass() { return 5; };
	virtual bool isMaskable() { return false; };

};

class Converter : public Device {
public:
	Converter();
	virtual dword Color() { return 0x04f6f4f; }; 
	virtual int GetDeviceFamily() { return TYPE_CONVERTER; };

	virtual bool isMaskable() { return false; };
};


#endif // !defined(AFX_FILTER_H__7ECDF35C_FE0C_47B4_9845_02BF3998EEA9__INCLUDED_)
