#pragma once
#include "wmpacket.h"
#include "mesh.h"

class MeshPacket :
	public WMPacket
{
public:
	MeshPacket(void);
	virtual ~MeshPacket(void);

	virtual int getType() { return WMP_mesh; };
	virtual char *getTypeName() { return "Mesh"; };
	virtual dword Color() { return 0x00ff0000; };

	virtual int getHeapUsage() { return 0; };

	virtual WMPacket *Clone();			// Return a copy of this WMPacket-derived packet
	virtual bool Load(std::istream &input) { assert(false); return false; };	
	virtual bool Save(std::ostream &output) { assert(false); return false; };

	TerrainMesh &get() { return mesh; };
	void assign(TerrainMesh &_mesh) { mesh = _mesh; };

private:
	MeshPacket(const MeshPacket &other);
	MeshPacket &operator=(const MeshPacket &other);

	virtual void Kill();		// Call to delete its own type
	virtual void clearContents() { };

	TerrainMesh	mesh;
};

// Safe Accessor inline function to provide a safe way to cast WMPacket to HField
// in debug mode it will assert if the packet is not a HF
inline MeshPacket *MESH(WMPacket *pack) { 
	if (pack) {
		bool ok = pack->getType() == WMP_mesh;
		if (!ok)
			return NULL;
	}
	return (MeshPacket*) pack; 
};


inline MeshPacket *GetNewMeshPacket() {
	MeshPacket *tc = MESH(WMGlobal->GetPacket(WMP_mesh));
	return tc; 
};