#pragma once
#include "wmpacket.h"

#include <string>

class WMPacket;

class TextPacket :
	public WMPacket
{
public:
	TextPacket(void);
	~TextPacket(void);

	virtual int getType() { return WMP_text; };
	virtual char *getTypeName() { return "Text"; };
	virtual dword Color() { return 0x007f7f7f; };
	virtual WMPacket *Clone();			// Return a copy of this WMPacket-derived packet
	virtual bool Load(std::istream &input) { assert(false); return false; };	
	virtual bool Save(std::ostream &output) { assert(false); return false; };	

	virtual int getHeapUsage() { return 0;	};


	void setText(const char *txt);
	char *getText();
protected:
	virtual void Kill();		// Call to delete its own type
	virtual void clearContents() { };

	char *body;
};

// Safe Accessor inline function to provide a safe way to cast WMPacket to HField
// in debug mode it will assert if the packet is not a HF
inline TextPacket *TPACKET(WMPacket *pack) { 
	if (pack) {
		bool ok = pack->getType() == WMP_text;
		if (!ok)
			return NULL;
	}
	return (TextPacket*) pack; 
};


inline TextPacket *GetNewTextPacket() {
	TextPacket *tp = TPACKET(WMGlobal->GetPacket(WMP_text));
	return tp; 
};